// ignore_for_file: non_constant_identifier_names
import 'dart:convert';

import 'package:http/http.dart';

class Brainly {
  static Future<BrainlyRawResponse> searchRaw(
    String query, {
    String language_code = "id",
    int count_result = 5,
  }) async {
    var format_graphql =
        """query SearchQuery(\$query: String!, \$len: Int!) {\n  questionSearch(query: \$query, first: \$len, after: null) {\n    edges {\n      node {\n        id\n        databaseId\n        points\n        pointsForAnswer\n        pointsForBestAnswer\n        created\n        isClosed\n        content\n        author {\n          id\n          nick\n          receivedThanks\n          avatar {\n            url\n            thumbnailUrl\n          }\n          databaseId\n          description\n          helpedUsersCount\n          gender\n          created\n          specialRanks {\n            name\n          }\n          bestAnswersCount\n          answererLevel\n          points\n          rank {\n            name\n          }\n          friends {\n            count\n          }\n          answeringStreak {\n            pointsForToday\n            pointsForTomorrow\n            progressIncreasedToday\n            progress\n            canLotteryPointsBeClaimed\n          }\n          bestAnswersCountInLast30Days\n          questions {\n            count\n            edges {\n              node {\n                content\n                grade {\n                  name\n                }\n                subject {\n                  slug\n                }\n                points\n                pointsForBestAnswer\n                pointsForAnswer\n                isClosed\n                canBeAnswered\n                created\n                attachments {\n                  url\n                }\n                grade {\n                  name\n                }\n                eduLevel\n                answers {\n                  nodes {\n                    id\n                    databaseId\n                    content\n                    created\n                    isBest\n                    isConfirmed\n                    qualityScore\n                    points\n                    ratesCount\n                    verification {\n                      approval {\n                        approver {\n                          nick\n                          databaseId\n                        }\n                      }\n                    }\n                    attachments {\n                      url\n                    }\n                    canComment\n                    comments {\n                      count\n                      edges {\n                        node {\n                          databaseId\n                          deleted\n                          content\n                          author {\n                            id\n                            nick\n                            avatar {\n                              url\n                              thumbnailUrl\n                            }\n                            databaseId\n                            friends {\n                              count\n                            }\n                            receivedThanks\n                            points\n                            created\n                            description\n                          }\n                        }\n                      }\n                    }\n                  }\n                }\n              }\n            }\n          }\n        }\n        canBeAnswered\n        grade {\n          name\n        }\n        attachments {\n          url\n        }\n        lastActivity\n        subject {\n          slug\n        }\n        eduLevel\n        similar {\n          question {\n            content\n            author {\n              nick\n              avatar {\n                url\n                thumbnailUrl\n              }\n              id\n              databaseId\n              description\n              helpedUsersCount\n              gender\n              created\n              specialRanks {\n                name\n              }\n              bestAnswersCount\n              answererLevel\n              points\n              rank {\n                name\n              }\n              friends {\n                count\n              }\n              answeringStreak {\n                pointsForToday\n                pointsForTomorrow\n                progressIncreasedToday\n                progress\n                canLotteryPointsBeClaimed\n              }\n              bestAnswersCountInLast30Days\n              questions {\n                count\n                edges {\n                  node {\n                    content\n                    grade {\n                      name\n                    }\n                    subject {\n                      slug\n                    }\n                    points\n                    pointsForBestAnswer\n                    pointsForAnswer\n                    isClosed\n                    canBeAnswered\n                    created\n                    attachments {\n                      url\n                    }\n                    grade {\n                      name\n                    }\n                    eduLevel\n                    answers {\n                      nodes {\n                        id\n                        databaseId\n                        content\n                        created\n                        isBest\n                        isConfirmed\n                        points\n                        ratesCount\n                        verification {\n                          approval {\n                            approver {\n                              nick\n                              databaseId\n                            }\n                          }\n                        }\n                        attachments {\n                          url\n                        }\n                        canComment\n                        comments {\n                          count\n                          edges {\n                            node {\n                              content\n                              author {\n                                nick\n                                databaseId\n                                avatar {\n                                  url\n                                }\n                              }\n                            }\n                          }\n                        }\n                      }\n                    }\n                  }\n                }\n              }\n            }\n            id\n            databaseId\n            points\n            pointsForAnswer\n            pointsForBestAnswer\n            created\n            isClosed\n            canBeAnswered\n            grade {\n              name\n            }\n            eduLevel\n          }\n        }\n        content\n        answers {\n          hasVerified\n          nodes {\n            author {\n              receivedThanks\n              avatar {\n                url\n                thumbnailUrl\n              }\n              id\n              databaseId\n              description\n              helpedUsersCount\n              gender\n              created\n              specialRanks {\n                name\n              }\n              bestAnswersCount\n              answererLevel\n              points\n              rank {\n                name\n              }\n              friends {\n                count\n              }\n              answeringStreak {\n                pointsForToday\n                pointsForTomorrow\n                progressIncreasedToday\n                progress\n                canLotteryPointsBeClaimed\n              }\n              bestAnswersCountInLast30Days\n              questions {\n                count\n                edges {\n                  node {\n                    content\n                    grade {\n                      name\n                    }\n                    subject {\n                      slug\n                    }\n                    points\n                    pointsForBestAnswer\n                    pointsForAnswer\n                    isClosed\n                    canBeAnswered\n                    created\n                    attachments {\n                      url\n                    }\n                    grade {\n                      name\n                    }\n                    eduLevel\n                    answers {\n                      nodes {\n                        id\n                        databaseId\n                        content\n                        created\n                        isBest\n                        isConfirmed\n                        qualityScore\n                        points\n                        ratesCount\n                        verification {\n                          approval {\n                            approver {\n                              nick\n                              databaseId\n                            }\n                          }\n                        }\n                        attachments {\n                          url\n                        }\n                        canComment\n                        comments {\n                          count\n                          edges {\n                            node {\n                              id\n                              databaseId\n                              deleted\n                              content\n                              author {\n                                nick\n                                avatar {\n                                  url\n                                  thumbnailUrl\n                                }\n                                id\n                                databaseId\n                                friends {\n                                  count\n                                }\n                                receivedThanks\n                                points\n                                created\n                                description\n                              }\n                            }\n                          }\n                        }\n                      }\n                    }\n                  }\n                }\n              }\n            }\n            content\n            points\n            isBest\n            canComment\n            isConfirmed\n            qualityScore\n            thanksCount\n            ratesCount\n            comments {\n              edges {\n                node {\n                  id\n                  databaseId\n                  deleted\n                  content\n                  author {\n                    nick\n                    avatar {\n                      url\n                      thumbnailUrl\n                    }\n                    id\n                    databaseId\n                    friends {\n                      count\n                    }\n                    receivedThanks\n                    points\n                    created\n                    description\n                  }\n                }\n              }\n            }\n            attachments {\n              url\n            }\n          }\n        }\n      }\n    }\n  }\n}""";
    String url = "https://brainly.co.id/graphql/id";

    // id: 'https://brainly.co.id',
    // us: 'https://brainly.com',
    // es: 'https://brainly.lat',
    // pt: 'https://brainly.com.br',
    // ru: 'https://znanija.com',
    // ro: 'https://brainly.ro',
    // tr: 'https://eodev.com',
    // ph: 'https://brainly.ph',
    // pl: 'https://brainly.pl',
    // hi: 'https://brainly.in',
    // fr: 'https://nosdevoirs.fr',

    language_code = language_code.toLowerCase();

    Map data = {
      "operationName": "SearchQuery",
      "variables": {"query": query, "after": null, "len": count_result},
      "query": format_graphql
    };
    Response response = await post(
      Uri.parse(url),
      headers: {
        'Accept': 'application/json',
        "Access-Control-Allow-Origin": "*",
        "Content-Type": "application/json",
      },
      body: json.encode(data),
    );
    return BrainlyRawResponse(json.decode(response.body));
  }

  static Future<List<BrainlyResponse>> searchSimple({
    required String query,
    String language_code = "id",
    int limit = 5,
  }) async {
    BrainlyRawResponse api = await Brainly.searchRaw(
      query,
      language_code: language_code,
      count_result: limit,
    );
    var raw_datas = api.data!.questionSearch!.edges!;
    List<BrainlyResponse> brainlyResponses = [];
    for (var i = 0; i < raw_datas.length; i++) {
      var raw_data = raw_datas[i];
      if (raw_data!.node != null) {
        var question_data = raw_data.node!.content!;
        var answer_datas = raw_data.node!.answers!.nodes!;
        List<String> answer_array = [];
        for (var index = 0; index < answer_datas.length; index++) {
          var answer_data = answer_datas[index];
          answer_array.add(answer_data!.content!);
        }
        brainlyResponses.add(BrainlyResponse({
          "question": question_data,
          "answers": answer_array,
        }));
      }
    }
    return brainlyResponses;
  }
}

class BrainlyResponse {
  late Map rawData;

  /// brainly scraper
  BrainlyResponse(this.rawData);

  String? get question {
    try {
      return rawData["question"] as String;
    } catch (e) {
      return null;
    }
  }

  List<String?>? get answers {
    try {
      return (rawData["answers"] as List).cast<String?>();
    } catch (e) {
      return null;
    }
  }

  /// return original data json
  Map toMap() {
    return rawData;
  }

  /// return original data json
  Map toJson() {
    return rawData;
  }

  /// return string data encode json original data
  @override
  String toString() {
    return json.encode(rawData);
  }
}

/// brainly scraper
class BrainlyRawResponse {
  late Map rawData;

  /// brainly scraper
  BrainlyRawResponse(this.rawData);

  /// brainly scraper
  Data? get data {
    try {
      if (rawData["data"] is Map == false) {
        return null;
      }
      return Data(rawData["data"] as Map);
    } catch (e) {
      return null;
    }
  }

  /// return original data json
  Map toMap() {
    return rawData;
  }

  /// return original data json
  Map toJson() {
    return rawData;
  }

  /// return string data encode json original data
  @override
  String toString() {
    return json.encode(rawData);
  }
}

/// brainly scraper
class Data {
  late Map rawData;

  /// brainly scraper
  Data(this.rawData);

  /// brainly scraper
  QuestionSearch? get questionSearch {
    try {
      if (rawData["questionSearch"] is Map == false) {
        return null;
      }
      return QuestionSearch(rawData["questionSearch"] as Map);
    } catch (e) {
      return null;
    }
  }

  /// return original data json
  Map toMap() {
    return rawData;
  }

  /// return original data json
  Map toJson() {
    return rawData;
  }

  /// return string data encode json original data
  @override
  String toString() {
    return json.encode(rawData);
  }
}

/// brainly scraper
class QuestionSearch {
  late Map rawData;

  /// brainly scraper
  QuestionSearch(this.rawData);

  /// brainly scraper
  List<Edges?>? get edges {
    try {
      if (rawData["edges"] is List == false) {
        return null;
      }
      return (rawData["edges"] as List)
          .map((e) => Edges(e as Map))
          .toList()
          .cast<Edges>();
    } catch (e) {
      return null;
    }
  }

  /// return original data json
  Map toMap() {
    return rawData;
  }

  /// return original data json
  Map toJson() {
    return rawData;
  }

  /// return string data encode json original data
  @override
  String toString() {
    return json.encode(rawData);
  }
}

/// brainly scraper
class Edges {
  late Map rawData;

  /// brainly scraper
  Edges(this.rawData);

  /// brainly scraper
  Node? get node {
    try {
      if (rawData["node"] is Map == false) {
        return null;
      }
      return Node(rawData["node"] as Map);
    } catch (e) {
      return null;
    }
  }

  /// return original data json
  Map toMap() {
    return rawData;
  }

  /// return original data json
  Map toJson() {
    return rawData;
  }

  /// return string data encode json original data
  @override
  String toString() {
    return json.encode(rawData);
  }
}

/// brainly scraper
class Node {
  late Map rawData;

  /// brainly scraper
  Node(this.rawData);

  /// brainly scraper
  String? get id {
    try {
      if (rawData["id"] is String == false) {
        return null;
      }
      return rawData["id"] as String;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  int? get databaseId {
    try {
      if (rawData["databaseId"] is int == false) {
        return null;
      }
      return rawData["databaseId"] as int;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  int? get points {
    try {
      if (rawData["points"] is int == false) {
        return null;
      }
      return rawData["points"] as int;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  int? get pointsForAnswer {
    try {
      if (rawData["pointsForAnswer"] is int == false) {
        return null;
      }
      return rawData["pointsForAnswer"] as int;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  int? get pointsForBestAnswer {
    try {
      if (rawData["pointsForBestAnswer"] is int == false) {
        return null;
      }
      return rawData["pointsForBestAnswer"] as int;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  String? get created {
    try {
      if (rawData["created"] is String == false) {
        return null;
      }
      return rawData["created"] as String;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  bool? get isClosed {
    try {
      if (rawData["isClosed"] is bool == false) {
        return null;
      }
      return rawData["isClosed"] as bool;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  String? get content {
    try {
      if (rawData["content"] is String == false) {
        return null;
      }
      return rawData["content"] as String;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  Author? get author {
    try {
      if (rawData["author"] is Map == false) {
        return null;
      }
      return Author(rawData["author"] as Map);
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  bool? get canBeAnswered {
    try {
      if (rawData["canBeAnswered"] is bool == false) {
        return null;
      }
      return rawData["canBeAnswered"] as bool;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  Grade? get grade {
    try {
      if (rawData["grade"] is Map == false) {
        return null;
      }
      return Grade(rawData["grade"] as Map);
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  List<Attachments?>? get attachments {
    try {
      if (rawData["attachments"] is List == false) {
        return null;
      }
      return (rawData["attachments"] as List)
          .map((e) => Attachments(e as Map))
          .toList()
          .cast<Attachments>();
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  String? get lastActivity {
    try {
      if (rawData["lastActivity"] is String == false) {
        return null;
      }
      return rawData["lastActivity"] as String;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  Subject? get subject {
    try {
      if (rawData["subject"] is Map == false) {
        return null;
      }
      return Subject(rawData["subject"] as Map);
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  Object? get eduLevel {
    try {
      if (rawData["eduLevel"] is Object == false) {
        return null;
      }
      return rawData["eduLevel"] as Object;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  List<Similar?>? get similar {
    try {
      if (rawData["similar"] is List == false) {
        return null;
      }
      return (rawData["similar"] as List)
          .map((e) => Similar(e as Map))
          .toList()
          .cast<Similar>();
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  Answers? get answers {
    try {
      if (rawData["answers"] is Map == false) {
        return null;
      }
      return Answers(rawData["answers"] as Map);
    } catch (e) {
      return null;
    }
  }

  /// return original data json
  Map toMap() {
    return rawData;
  }

  /// return original data json
  Map toJson() {
    return rawData;
  }

  /// return string data encode json original data
  @override
  String toString() {
    return json.encode(rawData);
  }
}

/// brainly scraper
class Author {
  late Map rawData;

  /// brainly scraper
  Author(this.rawData);

  /// brainly scraper
  String? get id {
    try {
      if (rawData["id"] is String == false) {
        return null;
      }
      return rawData["id"] as String;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  String? get nick {
    try {
      if (rawData["nick"] is String == false) {
        return null;
      }
      return rawData["nick"] as String;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  int? get receivedThanks {
    try {
      if (rawData["receivedThanks"] is int == false) {
        return null;
      }
      return rawData["receivedThanks"] as int;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  Avatar? get avatar {
    try {
      if (rawData["avatar"] is Map == false) {
        return null;
      }
      return Avatar(rawData["avatar"] as Map);
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  int? get databaseId {
    try {
      if (rawData["databaseId"] is int == false) {
        return null;
      }
      return rawData["databaseId"] as int;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  String? get description {
    try {
      if (rawData["description"] is String == false) {
        return null;
      }
      return rawData["description"] as String;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  int? get helpedUsersCount {
    try {
      if (rawData["helpedUsersCount"] is int == false) {
        return null;
      }
      return rawData["helpedUsersCount"] as int;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  String? get gender {
    try {
      if (rawData["gender"] is String == false) {
        return null;
      }
      return rawData["gender"] as String;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  String? get created {
    try {
      if (rawData["created"] is String == false) {
        return null;
      }
      return rawData["created"] as String;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  List<Object?>? get specialRanks {
    try {
      if (rawData["specialRanks"] is List == false) {
        return null;
      }
      return (rawData["specialRanks"] as List).cast<Object>();
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  int? get bestAnswersCount {
    try {
      if (rawData["bestAnswersCount"] is int == false) {
        return null;
      }
      return rawData["bestAnswersCount"] as int;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  String? get answererLevel {
    try {
      if (rawData["answererLevel"] is String == false) {
        return null;
      }
      return rawData["answererLevel"] as String;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  int? get points {
    try {
      if (rawData["points"] is int == false) {
        return null;
      }
      return rawData["points"] as int;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  Rank? get rank {
    try {
      if (rawData["rank"] is Map == false) {
        return null;
      }
      return Rank(rawData["rank"] as Map);
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  Friends? get friends {
    try {
      if (rawData["friends"] is Map == false) {
        return null;
      }
      return Friends(rawData["friends"] as Map);
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  AnsweringStreak? get answeringStreak {
    try {
      if (rawData["answeringStreak"] is Map == false) {
        return null;
      }
      return AnsweringStreak(rawData["answeringStreak"] as Map);
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  int? get bestAnswersCountInLast30Days {
    try {
      if (rawData["bestAnswersCountInLast30Days"] is int == false) {
        return null;
      }
      return rawData["bestAnswersCountInLast30Days"] as int;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  Questions? get questions {
    try {
      if (rawData["questions"] is Map == false) {
        return null;
      }
      return Questions(rawData["questions"] as Map);
    } catch (e) {
      return null;
    }
  }

  /// return original data json
  Map toMap() {
    return rawData;
  }

  /// return original data json
  Map toJson() {
    return rawData;
  }

  /// return string data encode json original data
  @override
  String toString() {
    return json.encode(rawData);
  }
}

/// brainly scraper
class Avatar {
  late Map rawData;

  /// brainly scraper
  Avatar(this.rawData);

  /// brainly scraper
  String? get url {
    try {
      if (rawData["url"] is String == false) {
        return null;
      }
      return rawData["url"] as String;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  String? get thumbnailUrl {
    try {
      if (rawData["thumbnailUrl"] is String == false) {
        return null;
      }
      return rawData["thumbnailUrl"] as String;
    } catch (e) {
      return null;
    }
  }

  /// return original data json
  Map toMap() {
    return rawData;
  }

  /// return original data json
  Map toJson() {
    return rawData;
  }

  /// return string data encode json original data
  @override
  String toString() {
    return json.encode(rawData);
  }
}

/// brainly scraper
class Rank {
  late Map rawData;

  /// brainly scraper
  Rank(this.rawData);

  /// brainly scraper
  String? get name {
    try {
      if (rawData["name"] is String == false) {
        return null;
      }
      return rawData["name"] as String;
    } catch (e) {
      return null;
    }
  }

  /// return original data json
  Map toMap() {
    return rawData;
  }

  /// return original data json
  Map toJson() {
    return rawData;
  }

  /// return string data encode json original data
  @override
  String toString() {
    return json.encode(rawData);
  }
}

/// brainly scraper
class Friends {
  late Map rawData;

  /// brainly scraper
  Friends(this.rawData);

  /// brainly scraper
  int? get count {
    try {
      if (rawData["count"] is int == false) {
        return null;
      }
      return rawData["count"] as int;
    } catch (e) {
      return null;
    }
  }

  /// return original data json
  Map toMap() {
    return rawData;
  }

  /// return original data json
  Map toJson() {
    return rawData;
  }

  /// return string data encode json original data
  @override
  String toString() {
    return json.encode(rawData);
  }
}

/// brainly scraper
class AnsweringStreak {
  late Map rawData;

  /// brainly scraper
  AnsweringStreak(this.rawData);

  /// brainly scraper
  int? get pointsForToday {
    try {
      if (rawData["pointsForToday"] is int == false) {
        return null;
      }
      return rawData["pointsForToday"] as int;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  int? get pointsForTomorrow {
    try {
      if (rawData["pointsForTomorrow"] is int == false) {
        return null;
      }
      return rawData["pointsForTomorrow"] as int;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  bool? get progressIncreasedToday {
    try {
      if (rawData["progressIncreasedToday"] is bool == false) {
        return null;
      }
      return rawData["progressIncreasedToday"] as bool;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  int? get progress {
    try {
      if (rawData["progress"] is int == false) {
        return null;
      }
      return rawData["progress"] as int;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  bool? get canLotteryPointsBeClaimed {
    try {
      if (rawData["canLotteryPointsBeClaimed"] is bool == false) {
        return null;
      }
      return rawData["canLotteryPointsBeClaimed"] as bool;
    } catch (e) {
      return null;
    }
  }

  /// return original data json
  Map toMap() {
    return rawData;
  }

  /// return original data json
  Map toJson() {
    return rawData;
  }

  /// return string data encode json original data
  @override
  String toString() {
    return json.encode(rawData);
  }
}

/// brainly scraper
class Questions {
  late Map rawData;

  /// brainly scraper
  Questions(this.rawData);

  /// brainly scraper
  int? get count {
    try {
      if (rawData["count"] is int == false) {
        return null;
      }
      return rawData["count"] as int;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  List<Edges?>? get edges {
    try {
      if (rawData["edges"] is List == false) {
        return null;
      }
      return (rawData["edges"] as List)
          .map((e) => Edges(e as Map))
          .toList()
          .cast<Edges>();
    } catch (e) {
      return null;
    }
  }

  /// return original data json
  Map toMap() {
    return rawData;
  }

  /// return original data json
  Map toJson() {
    return rawData;
  }

  /// return string data encode json original data
  @override
  String toString() {
    return json.encode(rawData);
  }
}

/// brainly scraper
class Grade {
  late Map rawData;

  /// brainly scraper
  Grade(this.rawData);

  /// brainly scraper
  String? get name {
    try {
      if (rawData["name"] is String == false) {
        return null;
      }
      return rawData["name"] as String;
    } catch (e) {
      return null;
    }
  }

  /// return original data json
  Map toMap() {
    return rawData;
  }

  /// return original data json
  Map toJson() {
    return rawData;
  }

  /// return string data encode json original data
  @override
  String toString() {
    return json.encode(rawData);
  }
}

/// brainly scraper
class Subject {
  late Map rawData;

  /// brainly scraper
  Subject(this.rawData);

  /// brainly scraper
  String? get slug {
    try {
      if (rawData["slug"] is String == false) {
        return null;
      }
      return rawData["slug"] as String;
    } catch (e) {
      return null;
    }
  }

  /// return original data json
  Map toMap() {
    return rawData;
  }

  /// return original data json
  Map toJson() {
    return rawData;
  }

  /// return string data encode json original data
  @override
  String toString() {
    return json.encode(rawData);
  }
}

/// brainly scraper
class Attachments {
  late Map rawData;

  /// brainly scraper
  Attachments(this.rawData);

  /// brainly scraper
  String? get url {
    try {
      if (rawData["url"] is String == false) {
        return null;
      }
      return rawData["url"] as String;
    } catch (e) {
      return null;
    }
  }

  /// return original data json
  Map toMap() {
    return rawData;
  }

  /// return original data json
  Map toJson() {
    return rawData;
  }

  /// return string data encode json original data
  @override
  String toString() {
    return json.encode(rawData);
  }
}

/// brainly scraper
class Answers {
  late Map rawData;

  /// brainly scraper
  Answers(this.rawData);

  /// brainly scraper
  List<Nodes?>? get nodes {
    try {
      if (rawData["nodes"] is List == false) {
        return null;
      }
      return (rawData["nodes"] as List)
          .map((e) => Nodes(e as Map))
          .toList()
          .cast<Nodes>();
    } catch (e) {
      return null;
    }
  }

  /// return original data json
  Map toMap() {
    return rawData;
  }

  /// return original data json
  Map toJson() {
    return rawData;
  }

  /// return string data encode json original data
  @override
  String toString() {
    return json.encode(rawData);
  }
}

/// brainly scraper
class Nodes {
  late Map rawData;

  /// brainly scraper
  Nodes(this.rawData);

  /// brainly scraper
  String? get id {
    try {
      if (rawData["id"] is String == false) {
        return null;
      }
      return rawData["id"] as String;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  int? get databaseId {
    try {
      if (rawData["databaseId"] is int == false) {
        return null;
      }
      return rawData["databaseId"] as int;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  String? get content {
    try {
      if (rawData["content"] is String == false) {
        return null;
      }
      return rawData["content"] as String;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  String? get created {
    try {
      if (rawData["created"] is String == false) {
        return null;
      }
      return rawData["created"] as String;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  bool? get isBest {
    try {
      if (rawData["isBest"] is bool == false) {
        return null;
      }
      return rawData["isBest"] as bool;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  bool? get isConfirmed {
    try {
      if (rawData["isConfirmed"] is bool == false) {
        return null;
      }
      return rawData["isConfirmed"] as bool;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  Object? get qualityScore {
    try {
      if (rawData["qualityScore"] is Object == false) {
        return null;
      }
      return rawData["qualityScore"] as Object;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  int? get points {
    try {
      if (rawData["points"] is int == false) {
        return null;
      }
      return rawData["points"] as int;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  int? get ratesCount {
    try {
      if (rawData["ratesCount"] is int == false) {
        return null;
      }
      return rawData["ratesCount"] as int;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  Object? get verification {
    try {
      if (rawData["verification"] is Object == false) {
        return null;
      }
      return rawData["verification"] as Object;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  List<Object?>? get attachments {
    try {
      if (rawData["attachments"] is List == false) {
        return null;
      }
      return (rawData["attachments"] as List).cast<Object>();
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  bool? get canComment {
    try {
      if (rawData["canComment"] is bool == false) {
        return null;
      }
      return rawData["canComment"] as bool;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  Comments? get comments {
    try {
      if (rawData["comments"] is Map == false) {
        return null;
      }
      return Comments(rawData["comments"] as Map);
    } catch (e) {
      return null;
    }
  }

  /// return original data json
  Map toMap() {
    return rawData;
  }

  /// return original data json
  Map toJson() {
    return rawData;
  }

  /// return string data encode json original data
  @override
  String toString() {
    return json.encode(rawData);
  }
}

/// brainly scraper
class Comments {
  late Map rawData;

  /// brainly scraper
  Comments(this.rawData);

  /// brainly scraper
  int? get count {
    try {
      if (rawData["count"] is int == false) {
        return null;
      }
      return rawData["count"] as int;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  List<Object?>? get edges {
    try {
      if (rawData["edges"] is List == false) {
        return null;
      }
      return (rawData["edges"] as List).cast<Object>();
    } catch (e) {
      return null;
    }
  }

  /// return original data json
  Map toMap() {
    return rawData;
  }

  /// return original data json
  Map toJson() {
    return rawData;
  }

  /// return string data encode json original data
  @override
  String toString() {
    return json.encode(rawData);
  }
}

/// brainly scraper
class Question {
  late Map rawData;

  /// brainly scraper
  Question(this.rawData);

  /// brainly scraper
  String? get content {
    try {
      if (rawData["content"] is String == false) {
        return null;
      }
      return rawData["content"] as String;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  Author? get author {
    try {
      if (rawData["author"] is Map == false) {
        return null;
      }
      return Author(rawData["author"] as Map);
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  String? get id {
    try {
      if (rawData["id"] is String == false) {
        return null;
      }
      return rawData["id"] as String;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  int? get databaseId {
    try {
      if (rawData["databaseId"] is int == false) {
        return null;
      }
      return rawData["databaseId"] as int;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  int? get points {
    try {
      if (rawData["points"] is int == false) {
        return null;
      }
      return rawData["points"] as int;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  int? get pointsForAnswer {
    try {
      if (rawData["pointsForAnswer"] is int == false) {
        return null;
      }
      return rawData["pointsForAnswer"] as int;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  int? get pointsForBestAnswer {
    try {
      if (rawData["pointsForBestAnswer"] is int == false) {
        return null;
      }
      return rawData["pointsForBestAnswer"] as int;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  String? get created {
    try {
      if (rawData["created"] is String == false) {
        return null;
      }
      return rawData["created"] as String;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  bool? get isClosed {
    try {
      if (rawData["isClosed"] is bool == false) {
        return null;
      }
      return rawData["isClosed"] as bool;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  bool? get canBeAnswered {
    try {
      if (rawData["canBeAnswered"] is bool == false) {
        return null;
      }
      return rawData["canBeAnswered"] as bool;
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  Grade? get grade {
    try {
      if (rawData["grade"] is Map == false) {
        return null;
      }
      return Grade(rawData["grade"] as Map);
    } catch (e) {
      return null;
    }
  }

  /// brainly scraper
  Object? get eduLevel {
    try {
      if (rawData["eduLevel"] is Object == false) {
        return null;
      }
      return rawData["eduLevel"] as Object;
    } catch (e) {
      return null;
    }
  }

  /// return original data json
  Map toMap() {
    return rawData;
  }

  /// return original data json
  Map toJson() {
    return rawData;
  }

  /// return string data encode json original data
  @override
  String toString() {
    return json.encode(rawData);
  }
}

/// brainly scraper
class Similar {
  late Map rawData;

  /// brainly scraper
  Similar(this.rawData);

  /// brainly scraper
  Question? get question {
    try {
      if (rawData["question"] is Map == false) {
        return null;
      }
      return Question(rawData["question"] as Map);
    } catch (e) {
      return null;
    }
  }

  /// return original data json
  Map toMap() {
    return rawData;
  }

  /// return original data json
  Map toJson() {
    return rawData;
  }

  /// return string data encode json original data
  @override
  String toString() {
    return json.encode(rawData);
  }
}
